# Cookbook for Common User Cases

The following examples show how to use Easegress for different scenarios.

- [API Aggregator](./api_aggregator.md) - Aggregating many APIs into a single API.
- [Distributed Tracing](./distributed_tracing.md) - How to do APM tracing  - Zipkin.
- [FaaS](./faas.md) - Supporting Knative FaaS integration
- [Flash Sale](./flash_sale.md) - How to do high concurrent promotion sales with Easegress
- [Kubernetes Ingress Controller](./k8s_ingress_controller.md) - How to integrated with Kubernetes as ingress controller
- [LoadBalancer](./load_balancer.md) - A number of strategy of load balancing
- [MQTTProxy](./mqtt_proxy.md) - An Example to MQTT proxy with Kafka backend.
- [Performance](./performance.md) - Performance optimization - compression, caching etc.
- [Pipeline](./pipeline.md) - How to orchestrate HTTP filters for requests/responses handling
- [Resilience and Fault Tolerance](./resilience.md) - Circuit Breaker, Rate Limiter, Retryer, Time limiter, etc. (Porting from [Java resilience4j](https://github.com/resilience4j/resilience4j))
- [Security](./security.md) - How to do authenication by Header, JWT, HMAC, OAuth2, etc.
- [Service Proxy](./service_proxy.md) - Supporting the Microservice  registries - Zookeeper, Eureka, Consul, Nacos, etc.
- [WebAssembly](./wasm.md) - Using AssemblyScript to extend the Easegress
- [Workflow](./workflow.md) - An Example to make a workflow for a number of APIs.
